]> arthur.barton.de Git - backup-script.git/blobdiff - bin/backup-script
Unify and enhance usage information and script descriptions
[backup-script.git] / bin / backup-script
index fa149bb86831e7c923aee4eac5109f4c6ef0d6e0..9530410dee0e8d85b7e7b18ad9cefdba4d6cc00f 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/bash
 #
 # backup-script system for cloning systems using rsync
-# Copyright (c)2008-2015 Alexander Barton <alex@barton.de>
+# Copyright (c)2008-2016 Alexander Barton <alex@barton.de>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,6 +15,8 @@ PIDFILE="/var/run/$NAME.pid"
 
 DRYRUN=0
 VERBOSE=0
+TAG=""
+PREPOSTEXEC=1
 
 export LC_ALL=C
 
@@ -22,6 +24,7 @@ declare -i count_all=0
 declare -i count_started=0
 declare -i count_ok=0
 declare -i count_ok_vanished=0
+declare -i count_enabled=0
 
 destinations=""
 
@@ -29,6 +32,7 @@ destinations=""
 [ -d "/usr/local/etc/backup-script.d" ] \
        && conf_d="/usr/local/etc/backup-script.d" \
        || conf_d="/etc/backup-script.d"
+setup_exec=""
 pre_exec=""
 post_exec=""
 default_backup_type="rsync"
@@ -44,24 +48,29 @@ default_compress=1
 default_ping=1
 default_local=0
 default_generations=0
+default_io_timeout="1800"
 default_job_pre_exec=""
 default_job_post_exec=""
+default_tags=""
 
 Usage() {
-       echo "Usage: $NAME [<options>] [<system> [<system> [...]]]"
+       echo "Usage: $NAME [<options>] [<job> [<job> [...]]]"
        echo
-       echo "  -p, --progress    Show progress, see rsync(1)."
-       echo "  -n, --dry-run     Test run only, don't copy any data."
+       echo "  -n, --dry-run       Test run only, don't copy any data."
+       echo "  -p, --progress      Show progress, see rsync(1)."
+       echo "  -t TAG, --tag TAG   Only run jobs with tag TAG."
+       echo "  -x, --no-exec       Don't run global pre-/post-exec commands."
        echo
-       echo "When no <system> is given, all defined systems are used."
+       echo "When no <job> is given, all defined systems are used."
        echo
+       # shellcheck disable=SC2086
        echo -e $config_info
        echo
        exit 2
 }
 
 CleanUp() {
-       if [ -n "$post_exec" ]; then
+       if [[ -n "$pre_exec" && $PREPOSTEXEC -ne 0 ]]; then
                echo "Executing \"$post_exec\" ..."
                sh -c $post_exec
                if [ $? -ne 0 ]; then
@@ -74,7 +83,7 @@ CleanUp() {
 
 GotSignal() {
        echo
-       echo "--> Got break signal, cleaning up & aborting ..."
+       echo "--> Got signal, cleaning up & aborting ..."
        echo
        CleanUp
        echo -n "Aborted: "; date
@@ -228,6 +237,7 @@ Initialize_Last_SysTarget_Snapshot() {
        case "$fs" in
          "btrfs")
                # Search directory of last generation, if any
+               # shellcheck disable=SC2012
                last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
                if [ -n "$last" ]; then
                        if [ ! -d "$last" ]; then
@@ -278,6 +288,7 @@ done
 # Read in configuration file
 config_info="Configuration file is \"$conf\""
 if [ -r "$conf" ]; then
+       # shellcheck source=/dev/null
        source "$conf"
 else
        config_info="${config_info} (not readable, using defaults)"
@@ -292,6 +303,13 @@ while [ $# -gt 0 ]; do
          "-p"|"--progress")
                VERBOSE=1; shift
                ;;
+         "-t"|"--tag")
+               shift; TAG="$1"; shift
+               [ -n "$TAG" ] || Usage
+               ;;
+         "-x"|"--no-exec")
+               PREPOSTEXEC=0; shift
+               ;;
          "-"*)
                Usage
                ;;
@@ -315,9 +333,9 @@ if [ $? -ne 0 ]; then
        exit 1
 fi
 echo "Rsync command is $rsync, protocol version $rsync_proto."
-echo
 
-trap GotSignal SIGINT
+[[ -n "$TAG" ]] && echo "Running jobs tagged with \"$TAG\"."
+echo
 
 if [ $# -ge 1 ]; then
        for s in "$@"; do
@@ -325,12 +343,26 @@ if [ $# -ge 1 ]; then
                        echo "$NAME: Can' read \"${conf_d}/$s\"!"
                        exit 3
                fi
-               sys="$sys ${conf_d}/$s"
+               sys+=("${conf_d}/$s")
        done
 else
-       sys="${conf_d}/"*
+       sys=("${conf_d}/"*)
 fi
 
+if [[ -n "$setup_exec" && $PREPOSTEXEC -ne 0 ]]; then
+       echo "Executing \"$setup_exec\" ..."
+       sh -c $setup_exec
+       if [ $? -ne 0 ]; then
+               echo "Error: setup command failed!"; echo
+               echo "Aborting backup."; echo
+               exit 5
+       fi
+       sleep 2
+       echo
+fi
+
+trap GotSignal SIGINT SIGTERM
+
 # check and create PID file
 if [ -e "$PIDFILE" ]; then
        echo "Lockfile \"$PIDFILE\" already exists."
@@ -348,7 +380,7 @@ else
        echo "$$" >>"$PIDFILE"
 fi
 
-if [ -n "$pre_exec" ]; then
+if [[ -n "$pre_exec" && $PREPOSTEXEC -ne 0 ]]; then
        echo "Executing \"$pre_exec\" ..."
        sh -c $pre_exec
        if [ $? -ne 0 ]; then
@@ -361,7 +393,7 @@ if [ -n "$pre_exec" ]; then
        echo
 fi
 
-for f in $sys; do
+for f in "${sys[@]}"; do
        [[ -r "$f" && -f "$f" ]] || continue
 
        fname=$(basename "$f")
@@ -388,6 +420,8 @@ for f in $sys; do
        generations="$default_generations"
        job_pre_exec="$default_job_pre_exec"
        job_post_exec="$default_job_post_exec"
+       tags="$default_tags"
+       io_timeout="$default_io_timeout"
 
        # Compatibility with backup-pull(1) script: Save global values ...
        pre_exec_saved="$pre_exec"
@@ -400,6 +434,7 @@ for f in $sys; do
        unset post_exec
 
        # Read in system configuration file
+       # shellcheck source=/dev/null
        source "$f"
 
        # Compatibility with backup-pull(1) script: Fix up configuration
@@ -423,12 +458,28 @@ for f in $sys; do
                compress=0
        fi
 
-       # Make sure "source" ends with a slash ("/")
-       case "$source" in
-         "*/")
+       # Add "NONE" tag when no tags are given in the config file:
+       [[ -z "$tags" ]] && tags="NONE"
+       # Add "auto-tags":
+       [[ "$local" -eq 1 ]] && tags="$tags,LOCAL"
+       # Check tags
+       if [[ -n "$TAG" && "$TAG" != "ALL" ]]; then
+               echo "$tags" | grep -E "(^|,)$TAG(,|$)" >/dev/null 2>&1
+               if [ $? -ne 0 ]; then
+                       if [ "$DRYRUN" -ne 0 ]; then
+                               echo "Tags of system \"$system\" don't match \"$TAG\": \"$tags\". Skipped."
+                               echo
+                       fi
+                       continue
+               fi
+       fi
+
+       # Make sure "source_root" ends with a slash ("/")
+       case "$source_root" in
+         *"/")
                ;;
-         "*")
-               source="$source/"
+         *)
+               source_root="$source_root/"
        esac
 
        # Make sure "target" DOESN'T end with a slash ("/")
@@ -447,6 +498,14 @@ for f in $sys; do
 
        count_all=$count_all+1
 
+       # Check if job is disabled
+       if [ "$backup_type" = "disabled" ]; then
+               echo "Job is DISABLED and will be skipped."
+               echo; continue
+       fi
+
+       count_enabled=$count_enabled+1
+
        # Check target directory
        if [ -z "$target" ]; then
                echo "No target directory specified for \"$system\"!? Skipped!"
@@ -543,15 +602,16 @@ for f in $sys; do
 
        # prepare (remote) command ...
        if [[ "$backup_type" == "rsync" ]]; then
-               cmd="$rsync --archive"
+               cmd="$rsync --archive --timeout=$io_timeout"
                [ "$compress" -ne 0 ] && cmd="$cmd --compress"
                [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
-               cmd="$cmd --delete --delete-excluded --sparse"
+               cmd="$cmd --delete-during --delete-excluded --sparse"
                if [ "$VERBOSE" -gt 0 ]; then
                        [ "$rsync_proto" -ge 31 ] \
                                && cmd="$cmd --info=progress2" \
                                || cmd="$cmd --progress"
                fi
+               set -f
                if [ "$source_root" = "$default_source_root" ]; then
                        for dir in \
                                "/dev/**" \
@@ -574,6 +634,7 @@ for f in $sys; do
                        cmd="$cmd --exclude=$dir"
                done
                [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
+               set +f
 
                [ "$local" -eq 0 ] \
                        && cmd="$cmd ${user}@${system}:$source_root $sys_target/" \
@@ -604,12 +665,14 @@ for f in $sys; do
                $SHELL -c "$cmd"; ret=$?
                end_t=$(date "+%s")
 
-               echo "code=$ret" >"$stamp_file"
-               echo "start_t=$start_t" >>"$stamp_file"
-               echo "end_t=$end_t" >>"$stamp_file"
-               echo "cmd='$cmd'" >>"$stamp_file"
-               echo "backup_host='`hostname -f`'" >>"$stamp_file"
-               echo "backup_user='`id -un`'" >>"$stamp_file"
+               {
+                       echo "code=$ret"
+                       echo "start_t=$start_t"
+                       echo "end_t=$end_t"
+                       echo "cmd='$cmd'"
+                       echo "backup_host='$(hostname -f)'"
+                       echo "backup_user='$(id -un)'"
+               } >"$stamp_file"
        else
                echo " *** Trial run, not executing save command!"
                ret=0
@@ -644,6 +707,7 @@ for f in $sys; do
                fi
                # Clean up old generations
                declare -i gen_count=$generations+2
+               # shellcheck disable=SC2012
                to_delete=$(ls -1t "$sys_root" 2>/dev/null | tail -n+$gen_count | sort)
                if [[ -n "$to_delete" && $ok -eq 1 ]]; then
                        [ "$DRYRUN" -eq 0 ] \
@@ -657,6 +721,7 @@ for f in $sys; do
                                fi
                                last=$(stat "$dir/.stamp" 2>/dev/null | grep "^Modify: " \
                                 | cut -d':' -f2- | cut -d. -f1)
+                               # shellcheck disable=SC2086
                                echo "Removing backup from" $last "..."
                                if [ "$DRYRUN" -eq 0 ]; then
                                        DeleteSubvolume "$dir"
@@ -681,6 +746,7 @@ sync
 if [ "$DRYRUN" -eq 0 ]; then
        paths=""
        paths_zfs=""
+       # shellcheck disable=SC2086
        for dest in $(echo $destinations | sed -e 's/ /\n/g' | sort | uniq); do
                fs=$(GetFS "$dest")
                case $fs in
@@ -692,10 +758,12 @@ if [ "$DRYRUN" -eq 0 ]; then
                esac
        done
        if [ -n "$paths" ]; then
+               # shellcheck disable=SC2086
                df -h $paths
                echo
        fi
        if [ -n "$paths_zfs" ]; then
+               # shellcheck disable=SC2086
                zfs list $paths_zfs
                echo
        fi
@@ -706,7 +774,9 @@ CleanUp
 echo -n "Done: "; date
 echo
 [ $count_all -eq 1 ] && s="" || s="s"
-echo " - $count_all job$s defined,"
+[ $count_enabled -eq $count_all ] \
+       && echo " - $count_all job$s defined (all enabled)," \
+       || echo " - $count_all job$s defined ($count_enabled enabled),"
 [ $count_started -eq 1 ] && s="" || s="s"
 echo " - $count_started job$s started,"
 echo " - $count_ok done without errors."
@@ -716,7 +786,7 @@ if [ $count_started -ne $count_ok ]; then
        echo "----->  THERE HAVE BEEN ERRORS!  <-----"
        echo
        exit 6
-elif [ $count_all -ne $count_started ]; then
+elif [ $count_enabled -ne $count_started ]; then
        exit 7
 fi